;--------HEAD--------

;Source File Name:

;    uniwork.asm

;Module Name :

;    EFZdotNET_EX.exe

;Compiler(Assembler) & Linker :

;    MASM 9.0

;Original Author :

;    Advance(LOVEHINA-AVC)    2007.1.15

;Modifications :

;    Db    2008.2.15
;        wsprintf changed to wvsprintf
;        max frameskip frequency changed to 5
;        minor version incremented (1.2)

;Execution Environment:

;    Win32 subsystem user mode only. The "Administrators" privilege is required.

.386
.model	flat, stdcall
option	casemap : none

include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
includelib \masm32\lib\kernel32.lib
include \masm32\include\user32.inc
includelib \masm32\lib\user32.lib
include \masm32\include\shell32.inc
includelib \masm32\lib\shell32.lib
include \masm32\include\ws2_32.inc
includelib \masm32\lib\ws2_32.lib
include \masm32\include\winmm.inc
includelib \masm32\lib\winmm.lib
include \masm32\include\msvcrt.inc
includelib \masm32\lib\msvcrt.lib

.CONST

	ACT_CONNECT                     equ    0
	ACT_CANCEL                      equ    1
	ACT_PING                        equ    2
	ACT_INIT_CONFIG                 equ    3
	ACT_EXCHANGE_RANDOM_SEED        equ    4
	ACT_SYNC_DATA                   equ    5
	ACT_QUIT                        equ    6
	
	RPY_ACK                         equ    0
	RPY_IN_PLAY                     equ    1
	RPY_PING                        equ    2
	RPY_VER_NOT_MATCH               equ    3

	TID_STARTUP_INFORMATION         equ    1
	TID_VERSION_INFORMATION         equ    2
	TID_TRY_CONNECTION              equ    3
	TID_REPLY                       equ    4
	TID_ALREADY_IN_PLAY             equ    5
	TID_NO_RESPONSE                 equ    6
	TID_DENIED                      equ    7
	TID_OPPONENT_INFORMATION        equ    8
	TID_SET_FRAMESKIP_FREQUENCY     equ    9
	TID_FATAL_SOCKET_ERROR          equ    10
	TID_WAIT_CONNECTION             equ    11
	TID_EXE_VER_NOT_MATCH           equ    12
	TID_NETWORK_UNUSABLE            equ    13
	TID_FAILED_TO_RELEASE_SOCK      equ    14
	TID_ACCEPTED_CONNECTION         equ    15
	TID_TYPE_IP                     equ    16
	TID_FAILED_TO_CREATE_PROC       equ    17
	TID_FAILED_TO_CREATE_SOCKET     equ    18
	TID_SESSION_CANCELLED_BY_SELF   equ    19
	TID_SESSION_CANCELLED_BY_HOST   equ    20
	TID_TESTING_LATENCY             equ    21
	TID_INVALID_DESTINATION         equ    22
	TID_HOST_UNREACHABLE            equ    23
	TID_VER_NOT_MATCH               equ    24
	TID_INVALID_PARAMETER           equ    25
	TID_AVERAGE_LATENCY             equ    26
	TID_CONNECTION_TIMEOUT          equ    27
	TID_WAIT_FOR_HOST               equ    28
	
	TID_PLAYER_NAME                 equ    100
	TID_LOCATION                    equ    101
	TID_NETWORK_TYPE                equ    102
	TID_MAX_RETRY_COUNT             equ    103
	TID_MAX_TIMEOUT                 equ    104
	TID_MAX_OVERLAPPED_PACKET       equ    105
	TID_COMMUNICATION_PORT          equ    106
	TID_PLAYER_SIDE                 equ    107
	
	DIK_ESCAPE                      equ    1
	DIK_F1                          equ    3Bh
	DIK_F10                         equ    44h
	DIK_SUBTRACT                    equ    4Ah
	DIK_ADD                         equ    4Eh
	
	FOREGROUND_WHITE                equ    FOREGROUND_RED OR FOREGROUND_GREEN OR FOREGROUND_BLUE
	SO_WAIT_ANY_KEY                 equ    1
	
	GS_INIT                         equ    0
	GS_REACH_ENTRY                  equ    1
	GS_SYNC_EXCHANGE_DATA           equ    2
	GS_TERMINATING                  equ    3
	
	SS_ESC_PRESSED                  equ    1
	SS_INCREASE_FSF                 equ    2
	SS_DECREASE_FSF                 equ    4
	SS_GAME_QUITTED                 equ    8

	MIN_SYMBOLIC_DEFINITION_SIZE    equ    128
	MAX_SYMBOLIC_DEFINITION_SIZE    equ    1024 * 1024
	
	HASH_MOD_NUMBER                 equ    8BC5D801h ; 0D99A4EC7h
	HASH_EFZ_EXE_402                equ    0F815233Eh
	
	VER_MAJOR                       equ    1
	VER_MINOR                       equ    2

	MAX_MESSAGE_SIZE                equ    256
	MAX_RETRY_COUNT                 equ    99
	MAX_OVERLAPPED_PACKET           equ    9
	MAX_FRAMESKIP_FREQUENCY         equ    5
	
	MAX_QUEUE_SLOT                  equ    12
	
	MAX_TIMEOUT                     equ    2000
	
	USER_DEFINED_MIN_TIMEOUT        equ    20
	USER_DEFINED_MAX_TIMEOUT        equ    5000
	
	TAG_EFZ                         equ    'NZFE'

WIN32_FIND_DATA_W STRUCT

  dwFileAttributes      DWORD      ?
  ftCreationTime        FILETIME <>
  ftLastAccessTime      FILETIME <>
  ftLastWriteTime       FILETIME <>
  nFileSizeHigh         DWORD      ?
  nFileSizeLow          DWORD      ?
  dwReserved0           DWORD      ?
  dwReserved1           DWORD      ?
  cFileName             WORD MAX_PATH dup(?)
  cAlternate            WORD 14 dup(?)
  
WIN32_FIND_DATA_W ENDS

WIN32_INPUT_RECORD STRUCT

	EventType             WORD       ?
	Alignment             WORD       ?
	KeyEvent              KEY_EVENT_RECORD <>

WIN32_INPUT_RECORD ENDS

;Public data structure definition

PD_PLAYER_INPUT_RECORD STRUCT

	PlayerAction          BYTE       ?
	SystemState           BYTE       ?

PD_PLAYER_INPUT_RECORD ENDS

PD_GLOBAL_INPUT_RECORD STRUCT

	InputRecord1P         PD_PLAYER_INPUT_RECORD <>
	InputRecord2P         PD_PLAYER_INPUT_RECORD <>

PD_GLOBAL_INPUT_RECORD ENDS

PD_DATA_AVAILABLE STRUCT

	AvailableFrame        DWORD      ?
	CurrentPosition       DWORD      ?
	AvailablePosition     DWORD      ?
	GlobalInput           PD_GLOBAL_INPUT_RECORD 12 dup(<>)
	
PD_DATA_AVAILABLE ENDS

PD_DATA_HISTORY STRUCT

	CurrentPosition       DWORD      ?
	LocalInput            PD_PLAYER_INPUT_RECORD 12 dup(<>)
	
PD_DATA_HISTORY ENDS

PD_DATA_PUBLIC STRUCT

	CurrentPosition       BYTE       ?
	
PD_DATA_PUBLIC ENDS

;Protocol definition

PT_CONNECTION_REQUEST STRUCT

	ControlWord           BYTE       ACT_CONNECT
	Identifier            DWORD      TAG_EFZ
	MajorVersion          WORD       VER_MAJOR
	MinorVersion          WORD       VER_MINOR
	PlayerName            WORD       32 dup(?)
	Location              WORD       32 dup(?)
	NetworkType           WORD       32 dup(?)
	
PT_CONNECTION_REQUEST ENDS

PT_PING STRUCT

	ControlWord           BYTE       ACT_PING
	PacketOrder           BYTE       ?

PT_PING ENDS

PT_REPLY STRUCT

	ControlWord           BYTE       RPY_PING
	PacketOrder           BYTE       ?

PT_REPLY ENDS

PT_VER_NOT_MATCH STRUCT

	ControlWord           BYTE       RPY_VER_NOT_MATCH
	
PT_VER_NOT_MATCH ENDS

PT_ALREADY_IN_PLAY STRUCT

	ControlWord           BYTE       RPY_IN_PLAY

PT_ALREADY_IN_PLAY ENDS

PT_PUBLIC_CONTROL_WORD STRUCT

	ControlWord           BYTE       ?
	
PT_PUBLIC_CONTROL_WORD ENDS

PT_ACCEPT STRUCT

	ControlWord           BYTE       RPY_ACK
	Is1PSide              BYTE       ?
	MinorVersion          WORD       VER_MINOR
	PlayerName            WORD       32 dup(?)
	Location              WORD       32 dup(?)
	NetworkType           WORD       32 dup(?)
	
PT_ACCEPT ENDS

PT_INITIALIZATION_CONFIGURATION STRUCT

	ControlWord           BYTE       ACT_INIT_CONFIG
	FrameSkipFreq         BYTE       ?
	MaxRetryCount         BYTE       ?
	PacketResendCount     BYTE       ?
	MaxTimeout            WORD       ?
	
PT_INITIALIZATION_CONFIGURATION ENDS

PT_CANCEL_CURRENT_OPERATION STRUCT

	ControlWord           BYTE       ACT_CANCEL
	
PT_CANCEL_CURRENT_OPERATION ENDS

PT_SYNC_DATA STRUCT

	ControlWord           BYTE       ACT_SYNC_DATA
	CurrentFrame          DWORD      ?
	ActionData            PD_PLAYER_INPUT_RECORD 12 dup(<>)

PT_SYNC_DATA ENDS

PT_EXCHANGE_RANDOM_SEED STRUCT

	ControlWord           BYTE       ACT_EXCHANGE_RANDOM_SEED
	Seed                  DWORD      ?

PT_EXCHANGE_RANDOM_SEED ENDS

PT_QUIT_GAME STRUCT

	ControlWord           BYTE       ACT_QUIT

PT_QUIT_GAME ENDS

.DATA?

ALIGN    DWORD

	hStdInput             dd    ?

	hStdOutput            dd    ?
	
	hSocketEvent          dd    ?
	
	hSendEvent            dd    ?
	
	hFinishEvent          dd    ?
	
	SendParameter         dd    ?

	lpThreadContext       dd    ?
	
	lpCommandLine         dd    ?
	
	lpSendBuffer          dd    ?
	
	lpLargeBuffer         dd    ?
	
	lpDataAvailable       dd    ?
	
	lpDataHistory         dd    ?
	
	lpCurrentDir          dd    ?
	
	CommunicationPort     dd    ?
	
	hMainHeap             dd    ?
	
	lpSymbolText          dd    ?
	
	lpSymbolBound         dd    ?
	
	PrevousStackPointer   dd    ?
	
	OpponentIPAddress     dd    ?
	
	OpponentPort          dd    ?
	
	TempValue             dd    ?
	
	MaxTimeout            dd    ?
	
	MaxRetryCount         db    ?
	
	PacketResendCount     db    ?
	
	FrameSkipFreq         db    ?
	
	bHost                 db    ?
	
	b1PSide               db    ?
	
	PlayerSide            db    ?

.DATA
	
ALIGN    DWORD

	;                            rndseed peek_action           char_sel          battle_scen            title
	InterruptPoint        dd    004010FCh,0040D133h,007597B7h,0075D397h,007656A7h,00770DC7h,00775797h,007767A7h

	RemoteAddress         sockaddr_in <>
	
	hSocket               dd    0
	
	Int3Code              db    0CCh
	
	szEFZdotNET                db    "EFZ.NET EX",0
	
	szVersionInformation_Part1 db    " ",0,"0",0,".",0,"1",0,".",0,"2",0," ",0,"b",0,"e",0,"t",0,"a",0

	szVersionInformation_Part2 db    " ",0," ",0," ",0,"2",0,"0",0,"0",0,"8",0,".",0,"2",0,".",0,"1",0,"5",0,"\",0,"\",0
	
	szTargetFileName           db    "e",0,"f",0,"z",0,".",0,"e",0,"x",0,"e",0,0,0
	
	szMatchableSymbolicFileName db    "l",0,"a",0,"n",0,"g",0,"_",0,"*",0,".",0,"t",0,"x",0,"t",0,0,0

	szExceptionTitle           db    "Exception",0
	
	szWindows2000Required      db    "This application requires NT 5.0 (2000) or later versions of Windows system",0
	
	szErrorSymDefFileNotFound  db    "The symbolic definition file has not found",0
	
	szErrorSpecSymDefNotFound  db    "A specific symbolic definition has not found",0
	
	szErrorFileNotReadable     db    "Could not open or read a specified file",0
	
	szErrorInvalidSize         db    "The size of symbolic definition file is invalid",0
	
	szErrorBomMismatch         db    "The byte order mark of symbolic definition file is not the UTF-16 unicode format",0
	
	szErrorOutOfMemory         db    "Out of memory",0
	
	szErrorMessageFormat       db    "A fatal exception has occured at procedure ID %08u:",0Dh,0Ah,0Dh,0Ah,"%s.",0



.CODE

start:

	push	eax
	push	eax
	push	[ExitProcess]
	
AppMain    PROC

	LOCAL    tempvar  : DWORD
	LOCAL    procinfo : PROCESS_INFORMATION
	LOCAL    sinfo    : STARTUPINFO
	LOCAL    wd       : WSADATA
	
	call	Initialize
	call	[GetCommandLineW]
	dec	ebx
	mov	[lpCommandLine],eax
	jnz	ExceptedTerminate
	
L118:

	call	WaitForFinishEvent
	mov	eax,[hSocket]
	and	[SendParameter],0
	and	[OpponentIPAddress],0
	test	eax,eax
	jz	@f
	push	eax
	call	[closesocket]
	test	eax,eax
	jz	@f
	push	TID_FAILED_TO_RELEASE_SOCK
	call	LookupUnicodeItemText
	push	FOREGROUND_INTENSITY OR FOREGROUND_RED OR FOREGROUND_GREEN
	call	ShowConsoleMessageEx
	
@@:

	mov	eax,[lpCommandLine]
	test	eax,eax
	jz	@f
	lea	ecx,[tempvar]
	and	[lpCommandLine],NULL
	push	ecx
	push	eax
	call	[CommandLineToArgvW]
	dec	[tempvar]
	jle	@f
	mov	eax,[eax + 4]
	jmp	L154

@@:

	push	TID_TYPE_IP
	call	ShowConsoleMessage
	call	GetConsoleLineInput
	shr	ecx,3
	jz	@f
	shr	ecx,2
	jnz	@b
	mov	eax,[lpLargeBuffer]
	
L154:

	xor	edx,edx
	mov	esi,[lpSendBuffer]
	push	edx
	push	edx
	push	127
	push	esi
	push	-1
	push	eax
	push	edx
	push	edx
	call	[WideCharToMultiByte]	
	push	esi
	call	[inet_addr]
	cmp	eax,INADDR_NONE
	je	@f
	push	eax
	call	TryConnection
	jmp	L119
	
@@:

	call	WaitConnection
	
L119:

	inc	eax
	jz	ErrorOrCancelled
	inc	eax
	jz	FatalSocketError
	lea	ebx,[sinfo]
	lea	esi,[procinfo]
	push	SIZEOF STARTUPINFO
	pop	[ebx + STARTUPINFO.cb]
	push	ebx
	call	[GetStartupInfoW]
	xor	eax,eax
	push	esi
	push	ebx
	push	[lpCurrentDir]
	push	eax
	push	DEBUG_PROCESS OR DEBUG_ONLY_THIS_PROCESS
	push	eax
	push	eax
	push	eax
	push	eax
	push	OFFSET szTargetFileName
	call	[CreateProcessW]
	test	eax,eax
	jnz	@f
	push	TID_FAILED_TO_CREATE_PROC
	call	LookupUnicodeItemText
	push	FOREGROUND_INTENSITY OR FOREGROUND_RED
	call	ShowConsoleMessageEx
	pop	eax
	jmp	ExceptedTerminate
	
@@:

 	call	[FreeConsole]
	push	1
	call	[timeEndPeriod]
	push	THREAD_PRIORITY_BELOW_NORMAL
	push	[esi + PROCESS_INFORMATION.hThread]
	call	[SetThreadPriority]
	push	[lpThreadContext]
	push	[esi + PROCESS_INFORMATION.hThread]
	push	[esi + PROCESS_INFORMATION.hProcess]
	call	DebugMessageLoop
	
EndOfAppMain:

	ret
	
ErrorOrCancelled:

	test	ecx,ecx
	lea	eax,[ecx - WSABASEERR]
	jz	L189
	cmp	eax,WSAEINVAL - WSABASEERR
	je	L190
	cmp	eax,WSAEADDRNOTAVAIL - WSABASEERR
	je	L190
	cmp	eax,WSAENETUNREACH - WSABASEERR
	je	L190
	cmp	eax,WSAEHOSTUNREACH - WSABASEERR
	jne	@f
	push	TID_HOST_UNREACHABLE
	jmp	L188
	
@@:
	
	push	ecx
	push	TID_FATAL_SOCKET_ERROR
	jmp	L187
	
L190:

	push	TID_INVALID_DESTINATION
	
L188:

	call	ShowConsoleMessage
	
L189:
	
	jmp	L118

FatalSocketError:

	call	[WSAGetLastError]
	push	eax
	push	TID_FAILED_TO_CREATE_SOCKET
	
L187:
	
	call	LookupUnicodeItemText	
	call	TruncateString
	mov	esi,[lpLargeBuffer]
	push	esp
	push	eax
	push	esi
	call	[wvsprintfW]
	mov	ecx,eax
	add	esp,4 * 1
	mov	eax,esi
	push	FOREGROUND_INTENSITY OR FOREGROUND_RED
	call	ShowConsoleMessageEx
	
ExceptedTerminate:

	call	WaitForConsoleKeyDown
	jmp	EndOfAppMain

Initialize:

	mov	[PrevousStackPointer],esp
	call	[GetVersion]
	xor	ebx,ebx
	cmp	eax,5000000h
	jae	@f
	push	ebx
	mov	eax,OFFSET szWindows2000Required
	jmp	ShowErrorMessage
	
@@:
	
	push	ebx
	push	ebx
	push	ebx
	call	[HeapCreate]
	mov	[hMainHeap],eax
	call	[AllocConsole]
	push	OFFSET szEFZdotNET
	call	[SetConsoleTitleA]
	push	STD_OUTPUT_HANDLE
	push	STD_INPUT_HANDLE
	call	[GetStdHandle]
	mov	[hStdInput],eax
	call	[GetStdHandle]
	mov	[hStdOutput],eax
	lea	esi,[tempvar]
	push	1
	call	[timeBeginPeriod]
	push	esi
	push	14
	pop	ecx

@@:
	
	push	ebx
	dec	ecx
	jnz	@b
	call	[CreateEventW]
	mov	[hSocketEvent],eax
	call	[CreateEventW]
	mov	[hSendEvent],eax
	call	[CreateEventW]
	mov	[hFinishEvent],eax
	push	OFFSET SendThread
	push	ebx
	push	ebx
	call	[CreateThread]
	call	SaveCurrentEnvironment	
	call	LookupUnicodeLanguageStorageInformation
	push	TID_STARTUP_INFORMATION
	call	LookupUnicodeItemText
	push	FOREGROUND_INTENSITY OR FOREGROUND_GREEN OR FOREGROUND_BLUE
	call	ShowConsoleMessageEx
	push	TID_VERSION_INFORMATION
	call	ShowConsoleMessage
	mov	eax,OFFSET szVersionInformation_Part1
	push	(SIZEOF szVersionInformation_Part1 + SIZEOF szVersionInformation_Part2) / 2
	pop	ecx
	push	FOREGROUND_WHITE
	call	ShowConsoleMessageEx
	lea	eax,[wd]
	push	eax
	push	2
	call	[WSAStartup]
	test	eax,eax
	jz	@f
	push	TID_NETWORK_UNUSABLE
	call	LookupUnicodeItemText
	
L171:
	
	push	FOREGROUND_INTENSITY OR FOREGROUND_RED
	call	ShowConsoleMessageEx
	retn
	
L170:
	
	sub	esp,4
	mov	esi,[lpLargeBuffer]
	push	TID_INVALID_PARAMETER
	call	LookupUnicodeItemText
	call	TruncateString
	push	esp
	push	eax
	push	esi
	mov	edi,eax
	call	[wvsprintfW]
	mov	ecx,eax
	add	esp,4 * 1
	mov	eax,esi
	call	L171
	mov	eax,edi
	call	FreeHeapMemory
	retn
	
@@:	

	push	TID_COMMUNICATION_PORT
	call	LookupUnicodeItemNumeral
	and	eax,0FFFFh
	jz	L170
	mov	cl,ah
	shl	eax,8
	mov	al,cl
	mov	[CommunicationPort],eax
	push	TID_MAX_OVERLAPPED_PACKET
	call	LookupUnicodeItemNumeral
	test	eax,eax
	jz	L170
	cmp	eax,MAX_OVERLAPPED_PACKET
	ja	L170
	mov	[PacketResendCount],al
	push	TID_MAX_RETRY_COUNT
	call	LookupUnicodeItemNumeral
	cmp	eax,MAX_RETRY_COUNT
	ja	L170
	mov	[MaxRetryCount],al
	push	TID_MAX_TIMEOUT
	call	LookupUnicodeItemNumeral
	cmp	eax,USER_DEFINED_MIN_TIMEOUT
	jb	L170
	cmp	eax,USER_DEFINED_MAX_TIMEOUT
	ja	L170
	mov	[MaxTimeout],eax
	push	TID_PLAYER_SIDE
	call	LookupUnicodeItemNumeral
	cmp	eax,2
	ja	L170
	mov	[PlayerSide],al
	push	10
	mov	eax,OFFSET szTargetFileName
	call	OpenFileInternal
	xor	edi,edi
	mov	esi,eax
	push	edi
	push	eax
	call	[GetFileSize]	
	lea	ecx,[tempvar]
	push	edi
	push	ecx
	push	eax
	push	11
	call	AllocateHeapMemory
	push	eax
	push	esi
	mov	edi,eax
	call	[ReadFile]
	mov	ecx,[tempvar]
	or	eax,-1
	
L114:
	
	mov	edx,[edi + ecx - 4]
	test	edx,edx
	jz	@f
	mov	esi,eax
	shl	eax,5
	shr	esi,27
	or	eax,esi
	add	eax,edx
	xor	eax,HASH_MOD_NUMBER
	
@@:
	
	sub	ecx,4
	jg	L114
	cmp	eax,HASH_EFZ_EXE_402
	je	@f
	push	TID_EXE_VER_NOT_MATCH
	call	LookupUnicodeItemText
	push	FOREGROUND_INTENSITY OR FOREGROUND_RED OR FOREGROUND_GREEN
	call	ShowConsoleMessageEx
	
@@:
	
	inc	ebx
	retn

AppMain    ENDP

SendThread:

	push	[hFinishEvent]
	call	[SetEvent]
	push	INFINITE
	push	[hSendEvent]
	call	[WaitForSingleObject]
	mov	esi,[SendParameter]
	movzx	edi,[PacketResendCount]
	
T100:
	
  push	SIZEOF sockaddr_in
  push	OFFSET RemoteAddress
  push	0
  push	esi
	push	[lpSendBuffer]
	push	[hSocket]
	call	[sendto]
	cmp	eax,esi
	jb	T100
	je	@f
	call	[WSAGetLastError]
	cmp	eax,WSAEWOULDBLOCK
	je	T100
	mov	[SendParameter],eax
	jmp	SendThread
	
@@:
	
	dec	edi
	jnz	T100
	mov	[SendParameter],edi
	jmp	SendThread
	
SendBegin:

	push	INFINITE
	push	[hFinishEvent]
	call	[WaitForSingleObject]
	retn
	
SendReceiveData:	;  PROC    NumberOfBytesToBeSent, bWaitForSendToComplete
	
	cmp	DWORD PTR[esp + 4],0
	je	L122
	mov	eax,[SendParameter]
	test	eax,eax
	jnz	L121
	mov	eax,[esp + 4]
	push	[hSendEvent]
	mov	[SendParameter],eax
	call	[SetEvent]
	jmp	L122
	
L121:
	
	or	ecx,-1
	jmp	EndOfSendRecv
	
L122:

	cmp	DWORD PTR[esp + 8],0
	je	L134
	call	WaitForFinishEvent
	
L134:
	
	push	1
	push	1
	push	[hSocketEvent]
	call	[WaitForSingleObjectEx]
	push	ecx
	push	esp
	push	OFFSET RemoteAddress
	push	0
	push	MAX_MESSAGE_SIZE
	push	[lpLargeBuffer]
	push	[hSocket]
	call	[recvfrom]
	test	eax,eax
	pop	ecx
	jz	@f
	cmp	eax,SOCKET_ERROR
	jne	L120

@@:

	call	[WSAGetLastError]
	cmp	eax,WSAEWOULDBLOCK
	je	@f
	cmp	eax,WSAEMSGSIZE
	jne	L121
	
@@:
	
	xor	ecx,ecx
	jmp	EndOfSendRecv
	
L120:

	mov	ecx,eax
	
EndOfSendRecv:
	
	retn	8
	
AdjustStringContent:

	push	eax
	
@@:
	
	movzx	ecx,WORD PTR[eax]
	inc	eax
	inc	eax
	test	ecx,ecx
	jz	@f
	cmp	ecx,' '
	jae	@b
	and	WORD PTR[eax - 2],0
	
@@:

	pop	eax
	retn

CopyStringToSendBuffer:

	push	[esp + 8]
	call	LookupUnicodeItemText
	cmp	ecx,32
	jbe	@f
	push	32
	pop	ecx
	
@@:
	
	add	ecx,ecx
	push	ecx
	push	eax
	push	[esp + 12]
	push	64
	push	[esp + 20]
	call	[RtlZeroMemory]
	call	[RtlMoveMemory]
	retn	8

CreateSocket:

	push	IPPROTO_UDP
	push	SOCK_DGRAM
	push	AF_INET
	call	[socket]
	cmp	eax,INVALID_SOCKET
	je	EndOfCreateSock	
	push	eax
	push	FD_READ
	push	[hSocketEvent]
	push	eax
	call	[WSAEventSelect]
	pop	eax

EndOfCreateSock:
	
	retn
	
CopyNameToSendBuffer:

	lea	eax,[esi + PT_CONNECTION_REQUEST.PlayerName]
	push	TID_PLAYER_NAME
	push	eax
	call	CopyStringToSendBuffer
	lea	eax,[esi + PT_CONNECTION_REQUEST.Location]
	push	TID_LOCATION
	push	eax
	call	CopyStringToSendBuffer
	lea	eax,[esi + PT_CONNECTION_REQUEST.NetworkType]
	push	TID_NETWORK_TYPE
	push	eax
	call	CopyStringToSendBuffer
	retn

TryConnection    PROC    USES esi edi ebx    TargetIPAddress

	LOCAL    TotalLatency       : DWORD
	LOCAL    HighestLatency     : DWORD

	call	CreateSocket
	cmp	eax,INVALID_SOCKET
	jne	@f
	dec	eax
	jmp	EndOfTryConn
	
@@:

	mov	[hSocket],eax
	push	TID_TRY_CONNECTION
	call	ShowConsoleMessage
	call	SendBegin
	mov	esi,[lpSendBuffer]
	mov	edi,OFFSET RemoteAddress
	mov	eax,[CommunicationPort]
	mov	ecx,[TargetIPAddress]
	mov	[edi + sockaddr_in.sin_family],AF_INET
	mov	[edi + sockaddr_in.sin_port],ax
	mov	[edi + sockaddr_in.sin_addr.S_un.S_addr],ecx
	mov	[esi + PT_CONNECTION_REQUEST.ControlWord],ACT_CONNECT
	mov	[esi + PT_CONNECTION_REQUEST.Identifier],TAG_EFZ
	mov	DWORD PTR[esi + PT_CONNECTION_REQUEST.MajorVersion],(VER_MINOR SHL 16) OR VER_MAJOR
	;mov	[esi + PT_CONNECTION_REQUEST.MajorVersion],VER_MAJOR
	;mov	[esi + PT_CONNECTION_REQUEST.MinorVersion],VER_MINOR
	call	CopyNameToSendBuffer
	push	1
	push	SIZEOF PT_CONNECTION_REQUEST
	xor	edi,edi
	jmp	L127
	
L123:

	push	0
	push	0
	
L127:

	call	SendReceiveData
	inc	ecx
	jnz	@f
	
L142:
	
	mov	ecx,eax
	
L125:
	
	or	eax,-1
	jmp	EndOfTryConn
	
@@:

	dec	ecx
	jnz	@f
	call	[timeGetTime]
	test	edi,edi
	jnz	L147
	mov	edi,eax
	
L147:
	
	sub	eax,edi
	cmp	eax,MAX_TIMEOUT
	jb	L123
	
L145:
	
	push	TID_NO_RESPONSE
	jmp	L126
	
@@:
	
	mov	eax,[lpLargeBuffer]
	cmp	[eax + PT_PUBLIC_CONTROL_WORD.ControlWord],RPY_IN_PLAY
	je	L128
	cmp	[eax + PT_PUBLIC_CONTROL_WORD.ControlWord],RPY_VER_NOT_MATCH
	je	L133
	cmp	ecx,SIZEOF PT_ACCEPT
	jne	@f
	cmp	[eax + PT_PUBLIC_CONTROL_WORD.ControlWord],RPY_ACK
	je	L124
	
@@:
	
	push	TID_DENIED
	jmp	L126
	
L133:

	push	TID_DENIED
	call	ShowConsoleMessage
	push	TID_VER_NOT_MATCH
	jmp	L126
	
L128:
	
	push	TID_ALREADY_IN_PLAY
	
L126:
	
	call	ShowConsoleMessage
	xor	ecx,ecx
	jmp	L125
	
L124:

	mov	al,[eax + PT_ACCEPT.Is1PSide]
	xor	al,1
	mov	[b1PSide],al
	call	[timeGetTime]
	test	edi,edi
	jnz	@f
	mov	edi,eax
	
@@:
	
	sub	eax,edi
	push	eax
	push	TID_REPLY
	call	LookupUnicodeItemText
	call	TruncateString
	push	esp
	push	eax
	push	esi
	mov	edi,eax
	call	[wvsprintfW]
	mov	ecx,eax
	add	esp,4 * 1
	mov	eax,esi
	push	FOREGROUND_WHITE
	call	ShowConsoleMessageEx
	mov	eax,edi
	mov	esi,[lpLargeBuffer]
	call	FreeHeapMemory
	call	PrintOpponentInformation
	push	TID_TESTING_LATENCY
	call	ShowConsoleMessage
	call	[timeGetTime]
	xor	ebx,ebx
	mov	edi,eax
	mov	[bHost],bl
	mov	[TotalLatency],ebx
	mov	[HighestLatency],ebx
	
L143:

	call	SendBegin
	mov	eax,[lpSendBuffer]
	push	0
	push	SIZEOF PT_PING
	mov	[eax + PT_PING.ControlWord],ACT_PING
	mov	[eax + PT_PING.PacketOrder],bl
	jmp	L141

L137:

	push	0
	push	0

L141:

	call	SendReceiveData
	inc	ecx
	jz	L142
	dec	ecx
	jnz	@f
	
L144:
	
	call	[timeGetTime]
	sub	eax,edi
	cmp	eax,MAX_TIMEOUT
	jb	L137
	
L155:
	
	push	TID_CONNECTION_TIMEOUT
	jmp	L126

@@:

	cmp	[esi + PT_PUBLIC_CONTROL_WORD.ControlWord],RPY_PING
	jne	L144
	cmp	ecx,SIZEOF PT_REPLY
	jne	L144
	cmp	[esi + PT_REPLY.PacketOrder],bl
	jne	L144
	inc	ebx
	call	[timeGetTime]
	push	eax
	sub	eax,edi
	cmp	[HighestLatency],eax
	jae	L148
	mov	[HighestLatency],eax
	
L148:

	add	[TotalLatency],eax
	pop	edi
	cmp	ebx,9
	jne	L143
	mov	eax,[TotalLatency]
	sub	eax,[HighestLatency]
	shr	eax,3
	push	eax
	push	TID_AVERAGE_LATENCY
	call	LookupUnicodeItemText
	call	TruncateString
	push	esp
	push	eax
	push	esi
	mov	edi,eax
	call	[wvsprintfW]
	mov	ecx,eax
	add	esp,4 * 1
	mov	eax,esi
	push	FOREGROUND_WHITE
	call	ShowConsoleMessageEx
	mov	eax,edi
	call	FreeHeapMemory
	push	TID_WAIT_FOR_HOST
	call	ShowConsoleMessage
	call	[timeGetTime]
	mov	edi,eax
	
L156:
	
	push	0
	push	0
	call	SendReceiveData
	inc	ecx
	jz	L142
	dec	ecx
	jz	L156
	cmp	[esi + PT_PUBLIC_CONTROL_WORD.ControlWord],ACT_CANCEL
	je	L158
	cmp	[esi + PT_PUBLIC_CONTROL_WORD.ControlWord],ACT_INIT_CONFIG
	jne	L156
	cmp	ecx,SIZEOF PT_INITIALIZATION_CONFIGURATION
	jne	L156
	mov	al,[esi + PT_INITIALIZATION_CONFIGURATION.FrameSkipFreq]
	mov	cl,[esi + PT_INITIALIZATION_CONFIGURATION.MaxRetryCount]
	mov	[FrameSkipFreq],al
	mov	[MaxRetryCount],cl
	mov	al,[esi + PT_INITIALIZATION_CONFIGURATION.PacketResendCount]
	movzx	ecx,[esi + PT_INITIALIZATION_CONFIGURATION.MaxTimeout]
	mov	[PacketResendCount],al
	mov	[MaxTimeout],ecx
	xor	eax,eax
	
EndOfTryConn:
	
	ret
	
L158:
	
	push	TID_SESSION_CANCELLED_BY_HOST
	jmp	L126

TryConnection    ENDP

PrintOpponentInformation    PROC

	LOCAL    tempptr[12] : BYTE

	movzx	eax,[esi + PT_ACCEPT.MinorVersion]
	movzx	edx,[b1PSide]
	push	32
	pop	ecx
	push	eax
	inc	edx
	push	VER_MAJOR
	push	edx
	lea	eax,[esi + PT_ACCEPT.NetworkType]
	call	TruncateString
	mov	DWORD PTR[tempptr[0]],eax
	call	AdjustStringContent
	push	eax
	push	32
	pop	ecx
	lea	eax,[esi + PT_ACCEPT.Location]
	call	TruncateString
	mov	DWORD PTR[tempptr[4]],eax
	call	AdjustStringContent
	push	eax
	push	32
	pop	ecx
	lea	eax,[esi + PT_ACCEPT.PlayerName]
	call	TruncateString
	mov	DWORD PTR[tempptr[8]],eax
	call	AdjustStringContent
	push	eax
	push	TID_OPPONENT_INFORMATION
	call	LookupUnicodeItemText
	call	TruncateString
	push	esp
	push	eax
	push	esi
	mov	edi,eax
	call	[wvsprintfW]
	mov	ecx,eax
	add	esp,4 * 6
	mov	eax,esi
	push	FOREGROUND_WHITE
	call	ShowConsoleMessageEx
	push	-4
	pop	ebx
	mov	eax,edi
	jmp	@f
	
L129:
	
	mov	eax,DWORD PTR[tempptr[12] + ebx * 4]
	
@@:
	
	call	FreeHeapMemory
	inc	ebx
	jnz	L129
	ret
	
PrintOpponentInformation    ENDP

WaitConnection    PROC    USES esi edi ebx

	LOCAL    TotalLatency       : DWORD
	LOCAL    HighestLatency     : DWORD
	LOCAL    LocalIPAddress[32] : WORD

	call	CreateSocket
	cmp	eax,INVALID_SOCKET
	jne	@f
	
L130:
	
	dec	eax
	jmp	EndOfWaitConn
	
@@:

	mov	[bHost],al
	mov	edi,OFFSET RemoteAddress
	mov	[hSocket],eax
	mov	ebx,[lpSendBuffer]
	mov	ecx,[CommunicationPort]
	mov	[edi + sockaddr_in.sin_family],AF_INET
	mov	[edi + sockaddr_in.sin_port],cx
	and	[edi + sockaddr_in.sin_addr.S_un.S_addr],INADDR_ANY
	push	SIZEOF sockaddr_in
	push	edi
	push	eax
	call	[bind]
	test	eax,eax
	jnz	L130
	push	32768
	push	ebx
	call	[gethostname]
	push	ebx
	call	[gethostbyname]
	mov	eax,[eax + hostent.h_list]
	mov	eax,[eax]
	push	[eax]
	call	[inet_ntoa]
	lea	edi,[LocalIPAddress]
	push	32
	push	edi
	push	-1
	push	eax
	push	0
	push	CP_ACP
	call	[MultiByteToWideChar]
	mov	eax,[CommunicationPort]
	push	edi
	mov	ecx,eax
	shr	eax,8
	mov	ah,cl
	push	eax
	push	TID_WAIT_CONNECTION
	call	LookupUnicodeItemText
	call	TruncateString
	push	esp
	push	eax
	push	ebx
	mov	edi,eax
	call	[wvsprintfW]
	mov	ecx,eax
	add	esp,4 * 2
	mov	eax,ebx
	push	FOREGROUND_WHITE
	call	ShowConsoleMessageEx
	mov	eax,edi
	call	FreeHeapMemory
	movzx	eax,[PlayerSide]
	test	eax,eax
	jnz	@f
	call	[timeGetTime]
	and	eax,1
	jmp	L172
	
@@:

	dec	eax
	
L172:
	
	mov	[b1PSide],al
	
L131:
	
	push	0
	push	0
	
@@:

	call	SendReceiveData
	inc	ecx
	jnz	@f
	mov	ecx,eax
	or	eax,-1
	jmp	EndOfWaitConn
	
L132:

	call	SendBegin
	push	0
	push	SIZEOF PT_VER_NOT_MATCH
	mov	[ebx + PT_VER_NOT_MATCH.ControlWord],RPY_VER_NOT_MATCH
	jmp	@b
	
@@:

	dec	ecx
	jz	L131
	mov	esi,[lpLargeBuffer]
	cmp	[esi + PT_PUBLIC_CONTROL_WORD.ControlWord],ACT_CONNECT
	jne	L131
	cmp	ecx,SIZEOF PT_CONNECTION_REQUEST
	jne	L131
	cmp	[esi + PT_CONNECTION_REQUEST.Identifier],TAG_EFZ
	jne	L131
	cmp	[esi + PT_CONNECTION_REQUEST.MajorVersion],VER_MAJOR
	jne	L132	
	movzx	ecx,[RemoteAddress.sin_port]
	mov	eax,[RemoteAddress.sin_addr.S_un.S_addr]
	mov	dx,[RemoteAddress.sin_port]
	mov	[OpponentIPAddress],eax
	mov	[OpponentPort],edx
	push	ecx
	push	eax
	call	[inet_ntoa]
	lea	edi,[LocalIPAddress]
	push	32
	push	edi
	push	-1
	push	eax
	push	0
	push	CP_ACP
	call	[MultiByteToWideChar]
	push	edi
	push	TID_ACCEPTED_CONNECTION
	call	LookupUnicodeItemText
	call	TruncateString
	push	esp
	push	eax
	push	ebx
	mov	edi,eax
	call	[wvsprintfW]
	mov	ecx,eax
	add	esp,4 * 2
	mov	eax,ebx
	push	FOREGROUND_WHITE
	call	ShowConsoleMessageEx
	mov	eax,edi
	add	esi,SIZEOF PT_CONNECTION_REQUEST - SIZEOF PT_ACCEPT
	call	FreeHeapMemory
	push	ebx
	call	PrintOpponentInformation
	push	MB_OK
	call	[MessageBeep]
	push	TID_TESTING_LATENCY
	call	ShowConsoleMessage
	pop	ebx
	call	SendBegin
	mov	al,[b1PSide]
	mov	[ebx + PT_ACCEPT.ControlWord],RPY_ACK
	mov	[ebx + PT_ACCEPT.MinorVersion],VER_MINOR
	mov	[ebx + PT_ACCEPT.Is1PSide],al
	lea	esi,[ebx - (SIZEOF PT_CONNECTION_REQUEST - SIZEOF PT_ACCEPT)]
	call	CopyNameToSendBuffer
	xor	ebx,ebx
	mov	edi,[lpLargeBuffer]
	call	[timeGetTime]
	push	ebx
	push	SIZEOF PT_ACCEPT
	mov	[TotalLatency],ebx
	mov	[HighestLatency],ebx
	mov	esi,eax
	jmp	L139
	
L135:

	push	0
	push	0
	
L139:
	
	call	SendReceiveData
	inc	ecx
	jnz	@f
	mov	ecx,eax
	
L136:
	
	or	eax,-1
	jmp	EndOfWaitConn

@@:

	dec	ecx
	jnz	@f
	
L138:

	call	[timeGetTime]
	sub	eax,esi
	cmp	ebx,9
	je	L140
	cmp	eax,MAX_TIMEOUT
	jb	L135
	push	TID_CONNECTION_TIMEOUT
	call	ShowConsoleMessage
	
L152:
	
	xor	ecx,ecx
	jmp	L136
	
@@:

	push	ecx
	call	Is3rdPartConnectionRequest
	dec	eax
	pop	ecx
	jz	@f
	call	SendBegin
	mov	eax,[lpSendBuffer]
	push	0
	push	SIZEOF PT_ALREADY_IN_PLAY
	mov	[eax + PT_ALREADY_IN_PLAY.ControlWord],RPY_IN_PLAY
	jmp	L139

@@:

	cmp	[edi + PT_PUBLIC_CONTROL_WORD.ControlWord],ACT_PING
	jne	L138
	cmp	ecx,SIZEOF PT_PING
	jne	L138
	cmp	[edi + PT_PING.PacketOrder],bl
	jne	L138
	call	[timeGetTime]
	push	eax
	sub	eax,esi
	cmp	[HighestLatency],eax
	jae	L146
	mov	[HighestLatency],eax
	
L146:
	
	add	[TotalLatency],eax
	pop	esi
	call	SendBegin
	mov	eax,[lpSendBuffer]
	push	0
	push	SIZEOF PT_REPLY
	mov	[eax + PT_REPLY.PacketOrder],bl
	mov	[eax + PT_REPLY.ControlWord],RPY_PING
	inc	ebx
	jmp	L139
	
L140:

	mov	eax,[TotalLatency]
	sub	eax,[HighestLatency]
	shr	eax,3
	push	eax
	push	TID_AVERAGE_LATENCY
	call	LookupUnicodeItemText
	call	TruncateString
	mov	esi,eax
	push	esp
	push	eax
	push	edi
	call	[wvsprintfW]
	mov	ecx,eax
	add	esp,4 * 1
	mov	eax,edi
	push	FOREGROUND_WHITE
	call	ShowConsoleMessageEx
	mov	eax,esi
	call	FreeHeapMemory
	push	TID_SET_FRAMESKIP_FREQUENCY
	call	ShowConsoleMessage
	mov	esi,[lpSendBuffer]
	
@@:
	
	call	WaitForConsoleKeyDown
	test	eax,eax
	jz	@f
	cmp	eax,VK_ESCAPE
	je	@f
	cmp	eax,VK_0
	jb	@b
	cmp	eax,VK_5
	jbe	L153
	cmp	eax,VK_NUMPAD0
	jb	@b
	cmp	eax,VK_NUMPAD5
	ja	@b
	sub	eax,VK_NUMPAD0 - VK_0
	
L153:

	lea	ebx,[eax - VK_0 + 1]
	call	SendBegin
	push	0
	push	SIZEOF PT_INITIALIZATION_CONFIGURATION
	mov	[FrameSkipFreq],bl
	mov	al,[MaxRetryCount]
	mov	cl,[PacketResendCount]
	mov	[esi + PT_INITIALIZATION_CONFIGURATION.MaxRetryCount],al
	mov	[esi + PT_INITIALIZATION_CONFIGURATION.PacketResendCount],cl
	mov	eax,[MaxTimeout]
	mov	[esi + PT_INITIALIZATION_CONFIGURATION.ControlWord],ACT_INIT_CONFIG
	mov	[esi + PT_INITIALIZATION_CONFIGURATION.FrameSkipFreq],bl
	mov	[esi + PT_INITIALIZATION_CONFIGURATION.MaxTimeout],ax
	call	SendReceiveData
	xor	eax,eax

EndOfWaitConn:

	ret
	
@@:

	call	SendBegin
	push	0
	push	SIZEOF PT_CANCEL_CURRENT_OPERATION
	mov	[esi + PT_CANCEL_CURRENT_OPERATION.ControlWord],ACT_CANCEL
	call	SendReceiveData
	push	TID_SESSION_CANCELLED_BY_SELF
	call	ShowConsoleMessage
	jmp	L152

WaitConnection    ENDP

ExchangeData    PROC    USES esi ebx    NumberOfBytesToBeSent, bBlockOperation, lpFeedbackRoutine

	LOCAL    RetryCounter : DWORD
	
	xor	ebx,ebx
	call	[timeGetTime]
	cmp	[lpFeedbackRoutine],ebx
	mov	[RetryCounter],ebx
	mov	esi,eax
	jne	L165
	
L191:
	
	push	ebx
	push	ebx
	
L163:
	
	call	SendReceiveData
	inc	ecx
	jz	FailedToExchangeData
	dec	ecx
	jz	@f
	cmp	[bHost],bl
	je	L169
	push	ecx
	call	Is3rdPartConnectionRequest
	dec	eax
	pop	ecx
	jz	L169
	call	SendBegin
	mov	eax,[lpSendBuffer]
	push	ebx
	push	SIZEOF PT_ALREADY_IN_PLAY
	mov	[eax + PT_ALREADY_IN_PLAY.ControlWord],RPY_IN_PLAY
	jmp	L163
	
@@:
	
	cmp	[bBlockOperation],ecx
	je	EndOfExchangeData
	call	[timeGetTime]
	sub	eax,esi
	cmp	eax,[MaxTimeout]
	jb	L191
	mov	cl,[MaxRetryCount]
	add	esi,eax
	cmp	BYTE PTR[RetryCounter],cl
	je	FailedToExchangeData
	inc	BYTE PTR[RetryCounter]
	
L165:
	
	call	SendBegin
	push	ebx
	push	[NumberOfBytesToBeSent]
	mov	eax,[lpSendBuffer]
	call	[lpFeedbackRoutine]
	jmp	L163
	
L169:

	mov	eax,[lpLargeBuffer]
	cmp	[eax + PT_PUBLIC_CONTROL_WORD.ControlWord],ACT_QUIT
	jnz	EndOfExchangeData
	
FailedToExchangeData:

	or	ecx,-1
	
EndOfExchangeData:

	ret
	
ExchangeData    ENDP

PerformRandomSeedExchangeProc:
	
	mov	ecx,[TempValue]
	mov	[eax + PT_EXCHANGE_RANDOM_SEED.ControlWord],ACT_EXCHANGE_RANDOM_SEED
	mov	[eax + PT_EXCHANGE_RANDOM_SEED.Seed],ecx
	retn
	
PerformActionDataExchangeProc:

	push	esi
	add	ebx,MAX_QUEUE_SLOT
	mov	[eax + PT_SYNC_DATA.ControlWord],ACT_SYNC_DATA
	mov	esi,[lpDataHistory]
	mov	ecx,[TempValue]
	mov	edx,[esi + PD_DATA_HISTORY.CurrentPosition]
	mov	[eax + PT_SYNC_DATA.CurrentFrame],ecx
	add	eax,PT_SYNC_DATA.ActionData
	
@@:
	
	dec	edx
	call	AdjustQueuePosition
	mov	cx,WORD PTR[esi + edx * 2 + PD_DATA_HISTORY.LocalInput.PlayerAction]
	mov	[eax],cx
	inc	eax
	inc	eax
	dec	ebx
	jnz	@b
	pop	esi
	retn

DebugMessageLoop    PROC    ProcessHandle, ThreadHandle, pThreadContext

	LOCAL    FrameCounter  : DWORD
	LOCAL    TimeLimit     : DWORD
	LOCAL    TimeElapsed   : DWORD
	LOCAL    IntCounter    : DWORD
	LOCAL    bEscKeyDown   : DWORD
	LOCAL    bSubKeyDown   : DWORD
	LOCAL    bAddKeyDown   : DWORD
	LOCAL    GameState     : DWORD
	LOCAL    b2PTrun       : DWORD
	LOCAL    CurrentAction : PD_GLOBAL_INPUT_RECORD
	LOCAL    dbgevent      : DEBUG_EVENT

	lea	edi,[b2PTrun]
	movzx	edx,[FrameSkipFreq]
	xor	eax,eax
	mov	[FrameCounter],edx
	stosd
	stosd
	stosd
	stosd
	stosd
	dec	edx
	mov	eax,[lpDataAvailable]
	mov	[eax + PD_DATA_AVAILABLE.AvailableFrame],edx

WaitForDebugEventLoop:

	push	0
	
L160:
	
	lea	esi,[dbgevent]
	push	esi
	call	[WaitForDebugEvent]
	test	eax,eax
	jnz	L117
	cmp	[GameState],GS_SYNC_EXCHANGE_DATA
	jne	@f
	mov	esi,[lpDataAvailable]
	push	eax
	push	eax
	call	UpdateInputRecord
	test	ecx,ecx
	jl	ProcessTerminated
	
@@:

	push	1
	jmp	L160

L117:
	
	cmp	[esi + DEBUG_EVENT.dwDebugEventCode],EXCEPTION_DEBUG_EVENT
	je	ExceptionOccurred
	cmp	[esi + DEBUG_EVENT.dwDebugEventCode],EXIT_PROCESS_DEBUG_EVENT
	je	ProcessTerminated
	
DebugUnhandled:

	push	DBG_EXCEPTION_NOT_HANDLED
	jmp	@f
	
UpdateContextAndContinue:

	push	edi
	push	[ThreadHandle]
	call	[SetThreadContext]
	
DebugContinue:

	push	DBG_CONTINUE
	
@@:
	
	push	[dbgevent.dwThreadId]
	push	[dbgevent.dwProcessId]
	call	[ContinueDebugEvent]
	jmp	WaitForDebugEventLoop
	
ExceptionOccurred:

	cmp	[esi + DEBUG_EVENT.u.Exception.pExceptionRecord.ExceptionCode],EXCEPTION_BREAKPOINT
	jne	DebugUnhandled
	
ReachedBreakpoint:

	cmp	[GameState],GS_INIT
	jne	L159
	inc	[GameState]	; mov	[GameState],GS_REACH_ENTRY
	xor	esi,esi
	
@@:
	
	push	NULL
	push	1
	push	OFFSET Int3Code
	push	[esi * 4 + InterruptPoint]
	push	[ProcessHandle]
	call	[WriteProcessMemory]
	inc	esi
	cmp	esi,SIZEOF InterruptPoint / 4
	jne	@b
	jmp	DebugContinue
	
L159:

	cmp	[GameState],GS_TERMINATING
	mov	edi,[pThreadContext]
	je	ProcessTerminated
	push	edi
	push	[ThreadHandle]
	call	[GetThreadContext]
	mov	eax,[esi + DEBUG_EVENT.u.Exception.pExceptionRecord.ExceptionAddress]
	xor	ecx,ecx

@@:

	cmp	[InterruptPoint + ecx * 4],eax
	je	@f
	inc	ecx
	cmp	ecx,SIZEOF InterruptPoint / 4
	jne	@b
	jmp	ProcessTerminated
	
@@:
	
	test	ecx,ecx
	jz	L164
	dec	ecx
	jz	L166
	jmp	L167
	
L164:

	mov	eax,[edi + CONTEXT.regEax]
	mov	[TempValue],eax
	
@@:
	
	push	OFFSET PerformRandomSeedExchangeProc
	push	1
	push	SIZEOF PT_EXCHANGE_RANDOM_SEED
	call	ExchangeData
	test	ecx,ecx
	mov	eax,[lpLargeBuffer]
	jl	ProcessTerminated
	cmp	[eax + PT_PUBLIC_CONTROL_WORD.ControlWord],ACT_EXCHANGE_RANDOM_SEED
	jne	@b
	cmp	ecx,SIZEOF PT_EXCHANGE_RANDOM_SEED
	jne	@b
	cmp	[bHost],0
	lea	ecx,[edi + CONTEXT.regEax]
	jne	@f
	mov	eax,[eax + PT_EXCHANGE_RANDOM_SEED.Seed]
	mov	[ecx],eax
	
@@:

	sub	DWORD PTR[edi + CONTEXT.regEsp],4
	push	NULL
	push	4
	push	ecx
	push	[edi + CONTEXT.regEsp]
	push	[ProcessHandle]
	call	[WriteProcessMemory]
	inc	[GameState]	; mov	[GameState],GS_SYNC_EXCHANGE_DATA
	jmp	UpdateContextAndContinue
	
L166:

	;int 3
	cmp	[IntCounter],0
	je	@f

L168:

	;int 3
	xor	[b2PTrun],1
	mov	al,[CurrentAction.InputRecord1P.PlayerAction]
	jnz	L174
	mov	al,[CurrentAction.InputRecord2P.PlayerAction]
	
L174:

	lea	ecx,[edi + CONTEXT.regEbp]
	mov	[edi + CONTEXT.regEax],eax
	inc	[IntCounter]
	push	NULL
	push	4
	push	ecx
	push	[edi + CONTEXT.regEsp]
	push	[ProcessHandle]
	call	[ReadProcessMemory]
	add	[edi + CONTEXT.regEsp],4
	jmp	UpdateContextAndContinue
	
@@:

	mov	edx,[FrameCounter]
	mov	eax,[lpDataHistory]
	mov	[TempValue],edx
	mov	ecx,[edi + CONTEXT.regEax]
	mov	edx,[eax + PD_DATA_HISTORY.CurrentPosition]
	mov	esi,[lpDataAvailable]
	mov	[eax + edx * 2 + PD_DATA_HISTORY.LocalInput.PlayerAction],cl
	inc	edx
	call	AdjustQueuePosition
	mov	[eax + PD_DATA_HISTORY.CurrentPosition],edx
	cmp	[b1PSide],dh
	mov	edx,[esi + PD_DATA_AVAILABLE.CurrentPosition]
	je	@f
	mov	[esi + edx * 4 + PD_DATA_AVAILABLE.GlobalInput.InputRecord1P.PlayerAction],cl
	jmp	L186
		
@@:

	mov	[esi + edx * 4 + PD_DATA_AVAILABLE.GlobalInput.InputRecord2P.PlayerAction],cl
	
L186:
	
	inc	edx
	call	AdjustQueuePosition
	mov	[esi + PD_DATA_AVAILABLE.CurrentPosition],edx
	call	[timeGetTime]
	mov	ecx,eax
	mov	[TimeElapsed],eax
	mov	eax,[MaxTimeout]
	cdq
	mov	dl,[MaxRetryCount]
	mul	edx
	push	OFFSET PerformActionDataExchangeProc
	add	eax,ecx
	mov	[TimeLimit],eax
	
L183:
	
	push	0
	
L184:
	
	call	UpdateInputRecord
	test	ecx,ecx
	jl	ProcessTerminated
	mov	eax,[esi + PD_DATA_AVAILABLE.AvailableFrame]
	movzx	ecx,[FrameSkipFreq]
	add	eax,ecx
	mov	edx,[esi + PD_DATA_AVAILABLE.AvailablePosition]
	sub	eax,[FrameCounter]
	jg	L185
	call	[timeGetTime]
	mov	ecx,eax
	sub	eax,[TimeElapsed]
	cmp	[MaxTimeout],eax
	jb	@f
	push	0
	jmp	L183
	
@@:

	cmp	[TimeLimit],ecx
	jb	ProcessTerminated
	push	OFFSET PerformActionDataExchangeProc
	push	1
	mov	[TimeElapsed],ecx
	jmp	L184
	
L185:

	sub	edx,eax
	call	AdjustQueuePosition
	mov	al,[esi + edx * 4 + PD_DATA_AVAILABLE.GlobalInput.InputRecord1P.PlayerAction]
	mov	cl,[esi + edx * 4 + PD_DATA_AVAILABLE.GlobalInput.InputRecord2P.PlayerAction]
	mov	[CurrentAction.InputRecord1P.PlayerAction],al
	mov	[CurrentAction.InputRecord2P.PlayerAction],cl
	inc	[FrameCounter]
	jmp	L168
	
UpdateInputRecord: ;  PROC    bBlockOperation, lpExchangeDataCallback
	
	push	[esp + 8]
	push	[esp + 8]
	
L178:
	
	push	SIZEOF PT_SYNC_DATA	
	call	ExchangeData
	test	ecx,ecx
	jg	@f
	retn 8
	
@@:
	
	mov	eax,[lpLargeBuffer]
	cmp	[eax + PT_SYNC_DATA.ControlWord],ACT_SYNC_DATA
	jne	L180
	cmp	ecx,SIZEOF PT_SYNC_DATA
	mov	ebx,[eax + PT_SYNC_DATA.CurrentFrame]
	jne	L180
	sub	ebx,[esi + PD_DATA_AVAILABLE.AvailableFrame]
	jle	L180
	cmp	ebx,MAX_QUEUE_SLOT
	jge	L180
	mov	edx,[esi + PD_DATA_AVAILABLE.AvailablePosition]
	add	eax,PT_SYNC_DATA.ActionData.PlayerAction
	add	[esi + PD_DATA_AVAILABLE.AvailableFrame],ebx
	add	edx,ebx
	call	AdjustQueuePosition
	mov	[esi + PD_DATA_AVAILABLE.AvailablePosition],edx
	
L179:

	dec	edx
	call	AdjustQueuePosition
	cmp	[b1PSide],0
	mov	cx,[eax]
	jne	@f
	mov	WORD PTR[esi + edx * 4 + PD_DATA_AVAILABLE.GlobalInput.InputRecord1P.PlayerAction],cx
	jmp	L182
	
@@:

	mov	WORD PTR[esi + edx * 4 + PD_DATA_AVAILABLE.GlobalInput.InputRecord2P.PlayerAction],cx
	
L182:
	
	inc	eax
	inc	eax
	dec	ebx
	jg	L179
	
L180:

	push	0
	push	0
	jmp	L178

L167:

	;int 3
	mov	ebx,[edi + CONTEXT.regEbp]
	mov	esi,[lpLargeBuffer]
	sub	ebx,108h
	push	NULL
	push	DIK_ADD + 1
	push	esi
	push	ebx
	push	[ProcessHandle]
	call	[ReadProcessMemory]
	xor	ecx,ecx
	mov	eax,[lpDataAvailable]
	mov	[IntCounter],ecx
	mov	[esi + DIK_F1],ecx
	mov	[esi + DIK_F1 + 4],ecx
	mov	[esi + DIK_F1 + 8],ecx
	;lea	eax,[esi + DIK_F1]
	;push	DIK_F10 - DIK_F1
	;push	eax
	;call	[RtlZeroMemory]
	cmp	[esi + DIK_ESCAPE],ch
	je	@f
	or	ecx,SS_ESC_PRESSED
	
@@:
	
	cmp	[esi + DIK_ADD],ch
	mov	[esi + DIK_ESCAPE],ch
	je	@f
	cmp	BYTE PTR[bAddKeyDown],ch
	jne	L175
	or	ecx,SS_INCREASE_FSF
	mov	BYTE PTR[bAddKeyDown],cl
	jmp	L175
	
@@:

	mov	BYTE PTR[bAddKeyDown],ch
	
L175:
	
	cmp	[esi + DIK_SUBTRACT],ch
	je	@f
	cmp	BYTE PTR[bSubKeyDown],ch
	jne	L176
	or	ecx,SS_DECREASE_FSF
	mov	BYTE PTR[bSubKeyDown],cl
	jmp	L176
	
@@:

	mov	BYTE PTR[bSubKeyDown],ch

L176:

	mov	edx,[eax + PD_DATA_AVAILABLE.CurrentPosition]
	cmp	[b1PSide],ch
	lea	edx,[eax + edx * 4 + PD_DATA_AVAILABLE.GlobalInput.InputRecord1P.SystemState]
	jne	@f
	add	edx,PD_DATA_AVAILABLE.GlobalInput.InputRecord2P.SystemState - PD_DATA_AVAILABLE.GlobalInput.InputRecord1P.SystemState
	
@@:

	push	eax
	mov	[edx],cl
	mov	eax,[lpDataHistory]
	mov	edx,[eax + PD_DATA_HISTORY.CurrentPosition]
	mov	[eax + edx * 2 + PD_DATA_HISTORY.LocalInput.SystemState],cl
	pop	eax
	mov	cl,[FrameSkipFreq]
	push	ecx
	mov	edx,[eax + PD_DATA_AVAILABLE.AvailablePosition]
	add	ecx,[eax + PD_DATA_AVAILABLE.AvailableFrame]
	inc	ecx
	sub	ecx,[FrameCounter]
	sub	edx,ecx
	call	AdjustQueuePosition
	mov	cl,[eax + edx * 4 + PD_DATA_AVAILABLE.GlobalInput.InputRecord1P.SystemState]
	or	cl,[eax + edx * 4 + PD_DATA_AVAILABLE.GlobalInput.InputRecord2P.SystemState]
	test	cl,SS_ESC_PRESSED
	jz	@f
	cmp	BYTE PTR[bEscKeyDown],dh
	jne	L192
	mov	dh,80h

@@:

	mov	BYTE PTR[bEscKeyDown],dh

L192:

	mov	[esi + DIK_ESCAPE],dh 
	pop	edx
	test	cl,SS_INCREASE_FSF
	jz	@f
	;inc	edx
	
@@:

	test	cl,SS_DECREASE_FSF
	jz	@f
	;dec	edx
	
@@:
	
	test	edx,edx
	jnz	@f
	inc	edx
	
@@:
	
	cmp	edx,MAX_FRAMESKIP_FREQUENCY + 1
	jbe	@f
	mov	dl,MAX_FRAMESKIP_FREQUENCY + 1
	
@@:
	
	push	NULL
	push	DIK_ADD + 1
	push	esi
	push	ebx
	push	[ProcessHandle]
	cmp	[FrameSkipFreq],dl
	mov	[FrameSkipFreq],dl
	jbe	@f
	mov	ecx,[eax + PD_DATA_AVAILABLE.AvailableFrame]
	inc	ecx
	mov	[eax + PD_DATA_AVAILABLE.AvailableFrame],ecx
	add	ecx,edx
	sub	ecx,[FrameCounter]
	mov	edx,[eax + PD_DATA_AVAILABLE.AvailablePosition]
	sub	edx,ecx
	call	AdjustQueuePosition
	and	DWORD PTR[eax + edx * 4 + PD_DATA_AVAILABLE.GlobalInput.InputRecord1P.PlayerAction],0
	
@@:
	
	call	[WriteProcessMemory]
	add	[edi + CONTEXT.regEip],03Eh
	jmp	UpdateContextAndContinue
	
ProcessTerminated:

	call	SendBegin
	mov	eax,[lpSendBuffer]
	push	1
	push	SIZEOF PT_QUIT_GAME
	mov	[eax + PT_QUIT_GAME.ControlWord],ACT_QUIT
	call	SendReceiveData
	ret

DebugMessageLoop    ENDP

AdjustQueuePosition:
	
	test	edx,edx
	jge	@f
	add	edx,MAX_QUEUE_SLOT
	
@@:

	cmp	edx,MAX_QUEUE_SLOT
	jb	@f
	sub	edx,MAX_QUEUE_SLOT
	
@@:

	retn

LookupUnicodeItemNumeral:

	push	[esp + 4]
	call	LookupUnicodeItemText
	mov	ecx,eax
	call	StringToUnsignedIntegerW
	retn	4

ShowConsoleMessage:

	push	[esp + 4]
	call	LookupUnicodeItemText
	push	FOREGROUND_WHITE
	call	ShowConsoleMessageEx
	retn	4

ShowConsoleMessageEx    PROC    USES esi edi ebx    Color

	LOCAL   NumberOfCharsRead : DWORD

	mov	esi,eax
	mov	edi,ecx
	push	[Color]
	call	SetConsoleTextColor
	lea	eax,[edi * 2 + 4]
	push	9
	call	AllocateHeapMemory
	mov	ebx,eax
	xor	ecx,ecx

L112:

	xor	edx,edx
	
L111:
	
	movzx	eax,WORD PTR[esi + ecx * 2]
	inc	ecx
	cmp	eax,'\'
	jne	@f
	mov	DWORD PTR[ebx + edx * 2],0A000Dh ; CR/LF
	inc	edx
	inc	edx
	jmp	L113
	
@@:
	
	mov	[ebx + edx * 2],ax
	inc	edx
	cmp	ecx,edi
	jb	L111
	
L113:

	lea	eax,[NumberOfCharsRead]
	push	ecx
	push	0
	push	eax
	push	edx
	push	ebx
	push	[hStdOutput]
	call	[WriteConsoleW]
	pop	ecx
	cmp	ecx,edi
	jb	L112
	mov	eax,ebx
	call	FreeHeapMemory
	push	FOREGROUND_WHITE
	call	SetConsoleTextColor
	ret

ShowConsoleMessageEx    ENDP

GetConsoleLineInput:

	push	ecx
	mov	eax,[lpLargeBuffer]
	mov	ecx,esp
	mov	edx,[hStdInput]
	push	NULL
	push	ecx
	push	127
	push	eax
	push	edx
	push	edx
	call	[FlushConsoleInputBuffer]
	call	[ReadConsoleW]
	pop	ecx
	retn

WaitForConsoleKeyDown    PROC    USES esi edi

	LOCAL    KeyRecord : WIN32_INPUT_RECORD
	
	lea	esi,[KeyRecord]
	mov	edi,[hStdInput]
	
@@:
	
	call	CheckNetworkEvent
	inc	eax
	jz	L115
	push	1
	push	edi
	call	[WaitForSingleObject]
	test	eax,eax
	jnz	@b
	push	ecx
	push	esp
	push	1
	push	esi
	push	edi
	call	[ReadConsoleInputW]
	pop	ecx
	push	edi
	call	[FlushConsoleInputBuffer]
	cmp	[esi + WIN32_INPUT_RECORD.EventType],KEY_EVENT
	jne	@b
	cmp	[esi + WIN32_INPUT_RECORD.KeyEvent.bKeyDown],0
	je	@b
	movzx	eax,[esi + WIN32_INPUT_RECORD.KeyEvent.wVirtualKeyCode]
	
L115:
	
	ret

WaitForConsoleKeyDown    ENDP

CheckNetworkEvent:

	xor	eax,eax
	cmp	[OpponentIPAddress],eax
	je	L149
	push	eax
	push	eax
	
L150:
	
	call	SendReceiveData
	inc	ecx
	jz	L116
	dec	ecx
	jz	L151
	call	Is3rdPartConnectionRequest
	dec	eax
	jz	L149
	call	SendBegin
	mov	eax,[lpSendBuffer]
	push	0
	push	SIZEOF PT_ALREADY_IN_PLAY
	mov	[eax + PT_ALREADY_IN_PLAY.ControlWord],RPY_IN_PLAY
	jmp	L150
	
L151:

	xor	eax,eax
	
L149:
	
	retn
	
L116:

	or	eax,-1
	retn

Is3rdPartConnectionRequest:

	xor	eax,eax
	mov	ecx,[OpponentIPAddress]
	mov	edx,[OpponentPort]
	cmp	[RemoteAddress.sin_addr.S_un.S_addr],ecx
	jne	@f
	cmp	[RemoteAddress.sin_port],dx
	jne	@f
	inc	eax
	
@@:

	retn

StringToUnsignedIntegerW:

;	ecx -> Pointer to a string that to be converted

	xor	eax,eax
	xor	edx,edx
	
L104:
	
	mov	dx,[ecx]
	inc	ecx
	inc	ecx
	cmp	edx,'0'
	jae	@f
	
L103:
	
	retn

@@:

	cmp	edx,'9'
	ja	L103
	sub	edx,'0'
	lea	eax,[eax + eax * 4]
	lea	eax,[edx + eax * 2]
	jmp	L104
	
SaveCurrentEnvironment:

	mov	esi,65536
	mov	eax,SIZEOF CONTEXT
	push	1
	call	AllocateHeapMemory
	mov	[lpThreadContext],eax
	mov	[eax + CONTEXT.ContextFlags],CONTEXT_CONTROL OR CONTEXT_INTEGER
	push	1
	mov	eax,esi
	call	AllocateHeapMemory
	mov	[lpSendBuffer],eax
	push	1
	mov	eax,esi
	call	AllocateHeapMemory
	mov	[lpLargeBuffer],eax
	push	1
	mov	eax,esi
	call	AllocateHeapMemory
	mov	[lpDataAvailable],eax
	add	eax,64
	mov	[lpDataHistory],eax
	push	1
	mov	eax,esi
	call	AllocateHeapMemory
	shr	esi,1
	push	eax
	push	esi
	mov	[lpCurrentDir],eax
	call	[GetCurrentDirectoryW]	
	retn
	
LookupUnicodeItemText    PROC    USES esi   ItemIndex

	xor	ecx,ecx
	mov	eax,[lpSymbolText]
	
L109:

	xor	esi,esi

L106:

	cmp	[lpSymbolBound],eax
	jbe	L107
	movzx	edx,WORD PTR[eax]
	inc	eax
	inc	eax
	cmp	edx,'"'
	jne	@f
	xor	ecx,edx
	
@@:
	
	test	ecx,ecx
	jnz	L106
	cmp	edx,'='
	je	L108
	cmp	edx,'0'
	jb	L109
	cmp	edx,'9'
	ja	L109
	sub	edx,'0'
	lea	esi,[esi + esi * 4]
	lea	esi,[edx + esi * 2]
	jmp	L106
	
L108:

	test	esi,esi
	jz	L106
	cmp	[ItemIndex],esi
	jne	L109
	mov	ecx,eax
	
@@:
	
	cmp	[lpSymbolBound],ecx
	jbe	L110
	mov	dx,[ecx]
	test	edx,edx
	je	L110
	cmp	edx,0Dh
	je	L110
	cmp	edx,0Ah
	je	L110
	inc	ecx
	inc	ecx
	jmp	@b
	
L110:
	
	sub	ecx,eax
	cmp	WORD PTR[eax],'"'
	jne	@f
	inc	eax
	dec	ecx
	inc	eax
	dec	ecx
	
@@:
	
	cmp	WORD PTR[eax + ecx - 2],'"'
	jne	@f
	dec	ecx
	dec	ecx
	
@@:
	
	shr	ecx,1
	jz	L107
	ret

L107:

	push	8
	mov	eax,OFFSET szErrorSpecSymDefNotFound
	jmp	ShowErrorMessage
	
LookupUnicodeItemText    ENDP

TruncateString:

	add	ecx,ecx
	push	ecx
	push	eax
	push	11
	lea	eax,[ecx + 2]
	call	AllocateHeapMemory
	push	eax
	call	[RtlMoveMemory]
	mov	eax,[esp - 12]
	retn

SetConsoleTextColor:

	push	[esp + 4]
	push	[hStdOutput]
	call	[SetConsoleTextAttribute]
	retn	4
	
FreeHeapMemory:

; eax -> Pointer to the buffer that to be released

	push	eax
	push	0
	push	[hMainHeap]
	call	[HeapFree]
	retn
	
WaitForFinishEvent:

	call	SendBegin
	push	[hFinishEvent]
	call	[SetEvent]
	retn

LookupUnicodeLanguageStorageInformation    PROC

	LOCAL    TempBuffer : DWORD
	LOCAL    nNumberOfBytesRead : DWORD
	LOCAL    DefaultFileName[MAX_PATH] : WORD
	LOCAL    FindData : WIN32_FIND_DATA_W
	
	push	esp	;	lea	eax,[FindData] \ push	eax
	push	OFFSET szMatchableSymbolicFileName
	call	[FindFirstFileW]
	mov	esi,eax
	inc	eax	;	cmp	eax,INVALID_HANDLE_VALUE
	jnz	@f	;	jne	@f
	push	2
	mov	eax,OFFSET szErrorSymDefFileNotFound
	jmp	ShowErrorMessage
	
@@:

	call	VerifySymbolicDefinition
	jmp	L101
	
@@:

	push	esp
	push	esi
	call	[FindNextFileW]
	test	eax,eax
	jz	@f
	
L101:
	
	lea	ecx,[esp + WIN32_FIND_DATA_W.cFileName + (5 * SIZEOF WORD)]
	call	StringToUnsignedIntegerW
	mov	edi,eax
	call	[GetSystemDefaultLangID]
	cmp	ax,di
	jne	@b
	call	VerifySymbolicDefinition
	
@@:
	
	push	esi
	call	[FindClose]
	lea	eax,[DefaultFileName]
	push	9
	call	OpenFileInternal
	mov	esi,eax
	push	NULL
	push	eax
	call	[GetFileSize]
	mov	edi,eax
	call	AllocateHeapMemory
	mov	[lpSymbolText],eax
	lea	ecx,[nNumberOfBytesRead]
	push	NULL
	push	ecx
	push	edi
	push	eax
	push	esi
	add	eax,edi
	mov	[lpSymbolBound],eax
	call	[ReadFile]
	test	eax,eax
	jnz	@f
	push	7
	mov	eax,OFFSET szErrorFileNotReadable
	jmp	ShowErrorMessage
	
@@:

	push	esi
	call	[CloseHandle]
	ret
	
VerifySymbolicDefinition:

	lea	eax,[esp + WIN32_FIND_DATA_W.cFileName + 4]	;	lea	eax,[FindData.cFileName]
	lea	ecx,[DefaultFileName]
	push	eax
	push	ecx
	call	[lstrcpyW]
	push	3
	call	OpenFileInternal
	lea	ecx,[TempBuffer]
	lea	edx,[nNumberOfBytesRead]
	
	push	eax	;	Parameter for CloseHandle
	
	push	NULL	;	Parameters for ReadFile
	push	edx
	push	2
	push	ecx
	push	eax
	
	push	NULL
	push	eax
	call	[GetFileSize]
	shr	eax,7	;	cmp	eax,MIN_SYMBOLIC_DEFINITION_SIZE
	jz	@f	;	jl	@f
	shr	eax,13	;	cmp	eax,MAX_SYMBOLIC_DEFINITION_SIZE
	jz	L100	;	jl	L100
	
@@:
	
	push	4
	mov	eax,OFFSET szErrorInvalidSize
	jmp	BranchIndex100
	
L100:
	
	call	[ReadFile]
	test	eax,eax
	jnz	@f
	push	5
	mov	eax,OFFSET szErrorFileNotReadable
	jmp	BranchIndex100
	
@@:
	
	call	[CloseHandle]
	cmp	WORD PTR[TempBuffer],0FEFFh	;	Is UTF-16 BOM ?
	je	@f
	push	6
	mov	eax,OFFSET szErrorBomMismatch
	jmp	BranchIndex100
	
@@:
	
	retn
	
BranchIndex100:

	jmp	ShowErrorMessage
	
LookupUnicodeLanguageStorageInformation    ENDP

OpenFileInternal:

;	eax -> Name of the file to open
;	[esp+4] -> Parameter for ShowErrorMessage routine, see declaration of ShowErrorMessage

	xor	ecx,ecx
	push	ecx
	push	ecx
	push	OPEN_EXISTING
	push	ecx
	push	FILE_SHARE_READ
	push	GENERIC_READ
	push	eax
	call	[CreateFileW]
	cmp	eax,INVALID_HANDLE_VALUE
	pop	edx
	je	@f
	pop	ecx
	jmp	edx
	
@@:
	
	mov	eax,OFFSET szErrorFileNotReadable
	jmp	ShowErrorMessage

AllocateHeapMemory:

;	eax -> Size of the buffer to be allocated
;	[esp+4] -> Parameter for ShowErrorMessage routine, see declaration of ShowErrorMessage

	push	eax
	push	HEAP_ZERO_MEMORY
	push	[hMainHeap]
	call	[HeapAlloc]
	test	eax,eax
	pop	edx
	jz	@f
	pop	ecx
	jmp	edx
	
@@:

	mov	eax,OFFSET szErrorOutOfMemory

ShowErrorMessage:

;	eax -> Pointer to a string that includes the description of exception
;	[esp] -> An integer ID to figure out the procedure which raised the exception present

	pop	ecx
	mov	esp,[PrevousStackPointer]	;	Restore the stack
	sub	esp,1024
	mov	esi,esp
	push	eax
	push	ecx
	push	OFFSET szErrorMessageFormat
	push	esi
	call	[wsprintfA]
	push	MB_ICONSTOP
	push	OFFSET szExceptionTitle
	push	esi
	push	0
	call	[MessageBoxA]
	push	-1
	call	[ExitProcess]
	
END    start

;--------END---------